// $Id: SLIPConverter.java,v 1.1 2002/04/02 09:44:10 cdjones Exp $
/*
 * SLIPConverter.java
 *
 */

package org.cdjj.jSLIP;

/**
 *
 * @author  cdjones
 * @version 
 */

public class SLIPConverter {
    public final static byte END     = (byte) 192; // 0300
    public final static byte ESC     = (byte) 219; // 0333
    public final static byte ESC_END = (byte) 220; // 0334
    public final static byte ESC_ESC = (byte) 221; // 0335

    public static boolean debug = false;
    
    public static void main(String[] args) {
        debug = true;
        byte[] input = new byte[256];
        for (int i = 0; i < 256; i++) {
            input[i] = (byte) i;
        }
        
        System.out.println("Input length: " + input.length);
        byte[] output = SLIPConverter.encode(input);
        System.out.println("Output length: " + output.length);
        for (int i = 0; i < output.length; i++) {
            System.out.println("Offset " + i + " \t" + (int) output[i]);
        }
        debug = false;
    }
    /**
     * n^2 setup.
     **/
    public static byte[] encode(byte[] data) {
        int dataLength = data.length;
        byte[] temp = new byte[dataLength * 2]; // Could require up to 2x space.
        byte[] output;
        int outputLength = 0;
        int i, j;
        
        for (i = 0, j = 0; i < dataLength;) {
            if (data[i] == END) {
                temp[j] = ESC;
                j++;
                temp[j] = ESC_END;
            } else if (data[i] == ESC) {
                temp[j] = ESC;
                j++;
                temp[j] = ESC_ESC;
            } else {
                temp[j] = data[i];
            }
            i++;
            j++;
        }
      output = new byte[j];
      
      for (i = 0; i < j; i++) {
          output[i] = temp[i];
          if (debug)
              System.out.println(i + ": " + 
                Integer.toHexString((int) output[i]));
      }
      return output;
    }
}

/* 
 * $Log: SLIPConverter.java,v $
 * Revision 1.1  2002/04/02 09:44:10  cdjones
 * Ugly, ugly, ugly code.  But it works.
 *
 */
